/* ***********************************************************
 * This file was automatically generated on 2017-01-25.      *
 *                                                           *
 * C# Bindings Version 2.1.12                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures UV light
	/// </summary>
	public class BrickletUVLight : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 265;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "UV Light Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_UV_LIGHT = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_UV_LIGHT_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_UV_LIGHT_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_UV_LIGHT_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_UV_LIGHT_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_UV_LIGHT = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_UV_LIGHT_REACHED = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletUVLight.SetUVLightCallbackPeriod"/>. The parameter is the UV Light 
		///  intensity of the sensor.
		///  
		///  <see cref="Tinkerforge.BrickletUVLight.UVLight"/> is only triggered if the intensity has changed since the
		///  last triggering.
		/// </summary>
		public event UVLightEventHandler UVLight;
		/// <summary>
		/// </summary>
		public delegate void UVLightEventHandler(BrickletUVLight sender, long uvLight);

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletUVLight.SetUVLightCallbackThreshold"/> is reached.
		///  The parameter is the UV Light intensity of the sensor.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletUVLight.SetDebouncePeriod"/>.
		/// </summary>
		public event UVLightReachedEventHandler UVLightReached;
		/// <summary>
		/// </summary>
		public delegate void UVLightReachedEventHandler(BrickletUVLight sender, long uvLight);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletUVLight(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			this.apiVersion[0] = 2;
			this.apiVersion[1] = 0;
			this.apiVersion[2] = 0;
			callbackWrappers[CALLBACK_UV_LIGHT] = new CallbackWrapper(OnUVLight);
			callbackWrappers[CALLBACK_UV_LIGHT_REACHED] = new CallbackWrapper(OnUVLightReached);

			responseExpected[FUNCTION_GET_UV_LIGHT] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_UV_LIGHT_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_UV_LIGHT_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_UV_LIGHT_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_UV_LIGHT_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_UV_LIGHT] = ResponseExpectedFlag.ALWAYS_FALSE;
			responseExpected[CALLBACK_UV_LIGHT_REACHED] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  Returns the UV light intensity of the sensor, the intensity is given
		///  in µW/cm².
		///  
		///  To get UV Index you have to divide the value by 250. For example, a UV Light
		///  intensity of 500µW/cm² is equivalent to an UV Index of 2.
		///  
		///  If you want to get the intensity periodically, it is recommended to use the
		///  callback <see cref="Tinkerforge.BrickletUVLight.UVLight"/> and set the period with 
		///  <see cref="Tinkerforge.BrickletUVLight.SetUVLightCallbackPeriod"/>.
		/// </summary>
		public long GetUVLight()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_UV_LIGHT);

			byte[] response = SendRequest(request);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the period in ms with which the <see cref="Tinkerforge.BrickletUVLight.UVLight"/> callback is triggered
		///  periodically. A value of 0 turns the callback off.
		///  
		///  <see cref="Tinkerforge.BrickletUVLight.UVLight"/> is only triggered if the intensity has changed since the
		///  last triggering.
		///  
		///  The default value is 0.
		/// </summary>
		public void SetUVLightCallbackPeriod(long period)
		{
			byte[] request = CreateRequestPacket(12, FUNCTION_SET_UV_LIGHT_CALLBACK_PERIOD);
			LEConverter.To((int)period, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletUVLight.SetUVLightCallbackPeriod"/>.
		/// </summary>
		public long GetUVLightCallbackPeriod()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_UV_LIGHT_CALLBACK_PERIOD);

			byte[] response = SendRequest(request);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletUVLight.UVLightReached"/> callback. 
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the intensity is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the intensity is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the intensity is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the intensity is greater than the min value (max is ignored)"
		///  </code>
		///  
		///  The default value is ('x', 0, 0).
		/// </summary>
		public void SetUVLightCallbackThreshold(char option, long min, long max)
		{
			byte[] request = CreateRequestPacket(17, FUNCTION_SET_UV_LIGHT_CALLBACK_THRESHOLD);
			LEConverter.To((char)option, 8, request);
			LEConverter.To((int)min, 9, request);
			LEConverter.To((int)max, 13, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletUVLight.SetUVLightCallbackThreshold"/>.
		/// </summary>
		public void GetUVLightCallbackThreshold(out char option, out long min, out long max)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_UV_LIGHT_CALLBACK_THRESHOLD);

			byte[] response = SendRequest(request);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.UIntFrom(9, response);
			max = LEConverter.UIntFrom(13, response);
		}

		/// <summary>
		///  Sets the period in ms with which the threshold callbacks
		///  
		///  * <see cref="Tinkerforge.BrickletUVLight.UVLightReached"/>,
		///  
		///  are triggered, if the thresholds
		///  
		///  * <see cref="Tinkerforge.BrickletUVLight.SetUVLightCallbackThreshold"/>,
		///  
		///  keep being reached.
		///  
		///  The default value is 100.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletUVLight.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnUVLight(byte[] response)
		{
			long uvLight = LEConverter.UIntFrom(8, response);

			var handler = UVLight;
			if(handler != null)
			{
				handler(this, uvLight);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnUVLightReached(byte[] response)
		{
			long uvLight = LEConverter.UIntFrom(8, response);

			var handler = UVLightReached;
			if(handler != null)
			{
				handler(this, uvLight);
			}
		}
	}
}
